<!DOCTYPE html>
<html xmlns:MadCap="http://www.madcapsoftware.com/Schemas/MadCap.xsd" lang="en-us" xml:lang="en-us" class="no-feedback" data-mc-search-type="Stem" data-mc-help-system-file-name="index.xml" data-mc-path-to-help-system="../../" data-mc-target-type="WebHelp2" data-mc-runtime-file-type="Topic" data-mc-preload-images="false" data-mc-in-preview-mode="false" data-mc-toc-path="Task Chains">
    <head>
        <meta charset="utf-8" />
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><title>Working with Task Chains</title>
        
        <link href="../../Skins/Default/Stylesheets/TextEffects.css" rel="stylesheet" />
        <link href="../../Skins/Default/Stylesheets/Topic.css" rel="stylesheet" />
        <link href="../Resources/Stylesheets/Styles.css" rel="stylesheet" />
        <script src="../../Resources/Scripts/jquery.min.js">
        </script>
        <script src="../../Resources/Scripts/plugins.min.js">
        </script>
        <script src="../../Resources/Scripts/MadCapAll.js">
        </script>
    </head>
    <map id="map1" name="map1">
        <area shape="rectangle" coords="840,44,1093,87" href="http://www.rapid7.com/products/metasploit/download.jsp" target="_blank" />
        <area shape="rectangle" coords="1107,48,1211,80" href="http://www.rapid7.com/products/metasploit/" target="_blank" />
    </map>
    <body>
        <p class="MCWebHelpFramesetLink MCWebHelpFramesetLinkTop" style="display: none;"><a href="../../index.html#12-task-chains/creating-scheduling-running-task-chains.html">Open topic with navigation</a>
        </p>
        <h1><a name="top"></a>Working with Task Chains</h1>
        <p style="font-weight: normal;">Task chains enable you to   automate and schedule the execution of a series of  repetitive tasks that you need to perform regularly, such as scans and bruteforce attacks. A task chain defines the tasks that will run, the settings for each task, and the conditions  required for the execution of those tasks. You create a task chain by adding the tasks you want to it, configuring the settings you want the tasks to use, arranging the tasks in the order you want them to run, and defining the schedule that it should follow. </p>
        <h2><a name="Creating"></a>Creating a Task Chain </h2>
        <ol>
            <li value="1">From within a project, select <b class="UISelection">Tasks &gt; Chains</b> from the Project tab bar. <br /><br />The task chains list appears. </li>
            <li value="2">Click the <b class="UISelection">New Task Chain</b> button. <br /><br /><img src="../Resources/Images/task-chains/task-chains-new-task-chain-button_567x169.png" title="New task chain" alt="New task chain" style="width: 567;height: 169;" /><br /><br />The New Task Chain page appears. </li>
            <li value="3">Enter a name for the task chain in the <b class="UISelection">Task Chain Name</b> field. <br /><br /><img src="../Resources/Images/task-chains/task-chains-name_554x108.png" style="width: 554;height: 108;" /></li>
            <li value="4">Click the <b class="UISelection">'+'</b> button to add a task. <br /><br /><img src="../Resources/Images/task-chains/task-chains-add-task-button-2_553x100.png" style="width: 553;height: 100;" /><br /><br />The task list appears. </li>
            <li value="5">Select a task from the list. <br /><br /><img src="../Resources/Images/task-chains/task-chains-tasks-list-2_550x155.png" style="width: 550;height: 155;" /><br /><br />A new task bubble appears on the task chain and the task configuration page displays below the task chain.<br /><br /><img src="../Resources/Images/task-chains/task-chains-added-task_537x274.png" style="width: 537;height: 274;" /></li>
            <li value="6">Configure the task as you usually would. <br /><br />The steps for configuring a task vary based on task type. For more information on configuring a specific task, see one of the following topics:</li>
        </ol>
        <ul>
            <li class="indentedList" value="1">
                <MadCap:conditionalText data-mc-conditions="Pro_Help_Conditions.OnlineOnly"><a href="../07-scanning/running-discovery-scan.html" class="online MCXref xref xrefonline">Running a Discovery Scan</a> <![CDATA[ ]]></MadCap:conditionalText>
            </li>
            <li class="indentedList" value="2">
                <MadCap:conditionalText data-mc-conditions="Pro_Help_Conditions.OnlineOnly"><a href="../07-scanning/importing-scan-data.html" class="online MCXref xref xrefonline">Importing Scan Data</a> <![CDATA[ ]]></MadCap:conditionalText>
            </li>
            <li class="indentedList" value="3">
                <MadCap:conditionalText data-mc-conditions="Pro_Help_Conditions.OnlineOnly"><a href="../10-nexpose/running-nexpose-scan.html" class="online MCXref xref xrefonline" data-mc-conditions="Pro_Help_Conditions.OnlineOnly">Running a Nexpose Scan</a>
                </MadCap:conditionalText>
            </li>
            <li class="indentedList" value="4">
                <MadCap:conditionalText data-mc-conditions="Pro_Help_Conditions.OnlineOnly">&#160;</MadCap:conditionalText>
            </li>
            <li class="indentedList" value="5">
                <MadCap:conditionalText data-mc-conditions="Pro_Help_Conditions.OnlineOnly"><a href="../06-modules/running-modules.html" class="online MCXref xref xrefonline">Running a Module</a>
                </MadCap:conditionalText>
            </li>
            <li class="indentedList" value="6">
                <MadCap:conditionalText data-mc-conditions="Pro_Help_Conditions.OnlineOnly"><a href="../13-exploitation/running-auto-exploit.html" class="online MCXref xref xrefonline">Running Automated Exploits</a>
                </MadCap:conditionalText>
            </li>
        </ul>
        <p>After you configure the task, you can add additional tasks to the task chain. When you finish building the task chain, you can create a schedule for the task chain or you can save the task chain to run on demand. </p>
        <p>For more information on scheduling a task chain, see <MadCap:conditionalText data-mc-conditions="Pro_Help_Conditions.OnlineOnly"> <![CDATA[ ]]><a href="scheduling-task-chains.html" class="online MCXref xref xrefonline">Task Chain Schedules</a></MadCap:conditionalText> .</p>
        <h2><a name="Adding"></a>Adding a Task to a Task Chain
</h2>
        <p>To add a task to a task chain, click the <b class="UISelection">'+' Add task</b> button. </p>
        <p>
            <img src="../Resources/Images/task-chains/task-chains-add-task-button_580x108.png" style="width: 580;height: 108;" />
        </p>
        <p>When you click the <b class="UISelection">'+'</b> button, the task list appears and shows you the tasks that can be added to the task chain. </p>
        <p>
            <img src="../Resources/Images/task-chains/task-chains-tasks-list_576x166.png" style="width: 576;height: 166;" />
        </p>
        <p>After you add the task, a new task bubble appears on the task chain, and the task configuration form displays below the task chain.</p>
        <p>
            <img src="../Resources/Images/task-chains/task-chains-bubble-form_559x154.png" style="width: 559;height: 154;" />
        </p>
        <p>The task bubble displays the tasks' position in the task chain. A task in the first position displays a number '1', a task in the second position displays a number '2', and so forth. You can click the task bubble and drag it to reposition it in the task chain. </p>
        <p>Any task bubble highlighted in red indicates that the task has not been configured correctly and the task chain cannot be saved. You can click on the task to fix the issues on the task form. </p>
        <h2><a name="Cloning"></a>Cloning a Task </h2>
        <p>When you clone a task, you are adding a copy of the task to the end of the task chain. You can move or modify the task as needed. </p>
        <p class="Note" data-mc-autonum="&lt;b&gt;Note:&lt;/b&gt; &#160;"><span class="autonumber"><span><b>Note:</b> &#160;</span></span>You should only clone tasks that are highlighted in blue, which indicate that there are no errors in the task configuration. </p>
        <p>To clone a task, click the task you want to clone to select it. </p>
        <p>
            <img src="../Resources/Images/task-chains/task-chains-select-task_579x102.png" style="width: 579;height: 102;" />
        </p>
        <p>Then, click the <b class="UISelection">Clone</b> button located in the task chain tool bar. </p>
        <p>
            <img src="../Resources/Images/task-chains/task-chains-clone-button_581x98.png" style="width: 581;height: 98;" />
        </p>
        <p>The cloned task will be added to the end of the task chain. </p>
        <p>
            <img src="../Resources/Images/task-chains/task-chains-cloned-task_580x107.png" style="width: 580;height: 107;" />
        </p>
        <p>If you need to reposition the task in the task chain, click on the task and drag it to the position you want it to appear in the task chain. </p>
        <h2><a name="Rearrang"></a>Rearranging Tasks in a Task Chain
</h2>
        <p>To move a task to a different position in the task chain, click the task bubble and drag it to reposition it in the task chain. </p>
        <p>
            <img src="../Resources/Images/task-chains/task-chains-rearrange_578x101.png" style="width: 578;height: 101;" />
        </p>
        <p>After you reposition the task,the position that displays in the task bubble is updated.  A task in the first position displays a number '1', a task in the second position displays a number '2', and so forth. </p>
        <p>
            <img src="../Resources/Images/task-chains/task-chains-rearrange-2_578x105.png" style="width: 578;height: 105;" />
        </p>
        <h2><a name="Adding2"></a>Adding a Post-Exploitation Module to a Task Chain</h2>
        <p>Post-exploitation is the phase that occurs after the system successfully exploits the target. It is the process that you use to identify information that helps you gain further access to the target or to additional systems within the target’s internal networks.</p>
        <p>When you manually run an attack against a target and get an active session, <span class="VariablesProductName">Metasploit Pro</span> provides actions that you can take against the session. The actions are available on the session page and vary based on the session type, such as shell or Meterpreter, and system information. For example, if the system opens a shell on a target, the actions that you can take include opening a command shell that connects to the target and collecting system data. If the system opens a Meterpreter session, you can do things like set up a proxy pivot or access the file system.</p>
        <p>Using the target system information, automatically displays the post-exploitation modules that are applicable to the target. This makes it easy for you to identify and choose the post-exploitation modules that you want to run against the target.</p>
        <p>When you work with task chains, the post-exploitation process is completely manual. You must search for the post-exploitation modules that you want to use based on the information that you have about the target. For example, if you know the target is a Windows system, and you want to capture screenshots, you may want to add a module task to your task chain that runs post/Windows/gather/screenshot. Or if you know your target is a Linux system, and you want to collect hashes, you may want to run <code>post/linux/gather/hashdump</code>.</p>
        <h2><a name="Removing"></a>Removing a Task from a Task Chain
</h2>
        <p>To remove a task from a task chain, click the task you want to delete to select it. </p>
        <p>
            <img src="../Resources/Images/task-chains/task-chains-select-task_576x102.png" style="width: 576;height: 102;" />
        </p>
        <p>Then, click the <b class="UISelection">Delete</b> button located in the task chain toolbar. </p>
        <p>
            <img src="../Resources/Images/task-chains/task-chains-delete-button_577x104.png" style="width: 577;height: 104;" />
        </p>
        <p>A dialog window will appear and prompt you to confirm that you want to delete the task. Click <b class="UISelection">OK</b> to delete the task from the task chain. </p>
        <p>You can only remove one task at a time. If you need to remove multiple tasks, please repeat the steps listed above or reset the task chain. For more information on resetting the task chain, see <MadCap:conditionalText data-mc-conditions="Pro_Help_Conditions.OnlineOnly"><a href="#Resettin" class="online MCXref xref xrefonline">Resetting a Task Chain</a> <![CDATA[ ]]></MadCap:conditionalText>.</p>
        <p class="Note" data-mc-autonum="&lt;b&gt;Note:&lt;/b&gt; &#160;"><span class="autonumber"><span><b>Note:</b> &#160;</span></span>After you remove a task from the task chain, you will not be able to recover the task. You will need to rebuild the task. </p>
        <h2><a name="Clearing"></a>Clearing the Project Data before a Task Chain Runs </h2>
        <p>If you want to clear the project data before the task chain runs, you can enable the <b class="UISelection">Delete previous project data</b> option. </p>
        <p>
            <img src="../Resources/Images/task-chains/task-chains-delete-previous-project_288x271.png" title="Task Chain Scheduler" alt="Task Chain Scheduler" style="width: 288;height: 271;" />
        </p>
        <p>Any and all data stored in the project, including hosts, collected evidence, session information, reports, and credentials will be wiped from the project. Enable this option only if you want to start the task chain with an empty project. Data cannot be recovered after it has been cleared from the project. </p>
        <h2><a name="Resettin"></a>Resetting a Task Chain</h2>
        <p>You can reset a task chain to clear all of the tasks from it. A task chain reset will remove all tasks and their configurations from the task chain. This action cannot be reverted. </p>
        <p>To reset a task chain, click the <b class="UISelection">Reset</b> button located in the task chain toolbar. </p>
        <p>
            <img src="../Resources/Images/task-chains/task-chains-reset-chain_564x104.png" style="width: 564;height: 104;" />
        </p>
        <p>A dialog window will appear and prompt you to confirm that you want to reset the task chain. Click <b class="UISelection">OK</b> to reset it. </p>
        <h2><a name="Running"></a>Running a Task Chain </h2>
        <p>You can run task chains on demand or outside the scope of its schedule. </p>
        <p>To run a task chain, select <b class="UISelection">Tasks &gt;&#160;Chains</b> from the Project tab bar. </p>
        <p>Select the task chain that you want to run.</p>
        <p>
            <img src="../Resources/Images/task-chains/task-chains-select-chain_551x161.png" title="Task chains list" alt="Task chains list" style="width: 551;height: 161;" />
        </p>
        <p>Click the <b class="UISelection">Run Now</b> button. </p>
        <p>
            <img src="../Resources/Images/task-chains/task-chains-run-button_548x161.png" style="width: 548;height: 161;" />
        </p>
        <p>A dialog window will appear and prompt you to confirm that you want to run the task chain. Click <b class="UISelection">OK</b> to run it. </p>
    </body>
</html>